package buildcraft.lib.misc.search;

import java.util.List;

import net.minecraft.client.util.SuffixArray;
import net.minecraft.profiler.Profiler;

import buildcraft.lib.misc.search.ISuffixArray.SearchResult;

/** An implementation of {@link ISuffixArray} that delegates to a vanilla minecraft {@link SuffixArray}. */
public final class VanillaSuffixArray<T> implements ISuffixArray<T> {
    private final SuffixArray<T> vanillaSuffixArray;

    public VanillaSuffixArray(SuffixArray<T> vanillaSuffixArray) {
        this.vanillaSuffixArray = vanillaSuffixArray;
    }

    public VanillaSuffixArray() {
        this(new SuffixArray<>());
    }

    @Override
    public void add(T obj, String name) {
        vanillaSuffixArray.func_194057_a(obj, name);
    }

    @Override
    public void generate(Profiler prof) {
        vanillaSuffixArray.func_194058_a();
    }

    @Override
    public SearchResult<T> search(String substring, int maxResults) {
        List<T> list = vanillaSuffixArray.func_194055_a(substring);
        if (list.size() > maxResults) {
            int count = list.size();
            list.subList(maxResults, list.size()).clear();
            return new SearchResult<>(list, count);
        }
        return new SearchResult<>(list);
    }
}
